package com.usercentrics.sdk.flutter.mock

import com.usercentrics.sdk.flutter.api.FakeFlutterMethodCall
import com.usercentrics.sdk.v2.location.data.UsercentricsLocation
import com.usercentrics.sdk.v2.settings.data.*

internal object GetCMPDataMock {

    val fakeCategories = listOf(
        UsercentricsCategory(
            categorySlug = "essential",
            description = "These technologies are required to activate the core functionality of the website.",
            isEssential = true,
            label = "Essential",
        )
    )
    val fakeUserLocation = UsercentricsLocation(
        countryCode = "PT",
        countryName = "Portugal",
        regionCode = ""
    )
    val fakeServices = listOf(
        UsercentricsService(
            templateId = "ABC",
            version = "1.2.3",
            type = "predefined",
            dataProcessor = "Google Ads",
            dataPurposes = listOf("Advertising Conversion Tracking"),
            processingCompany = "Google Ireland Limited, Google Building Gordon House",
            nameOfProcessingCompany = "Google Ireland Limited",
            addressOfProcessingCompany = "Google Building Gordon House",
            descriptionOfService = "This is a conversion tracking service. ",
            languagesAvailable = listOf("en"),
            dataCollectedList = listOf("IP adress"),
            dataPurposesList = listOf("Analytics"),
            dataRecipientsList = listOf("Google Ireland Limited"),
            legalBasisList = listOf("Art. 6 para. 1 s. 1 lit. a GDPR"),
            retentionPeriodList = listOf(),
            subConsents = listOf(),
            cookieNames = listOf(),
            language = "en",
            isLatest = false,
            isShared = false,
            shareCustomConsent = "",
            linkToDpa = "",
            defaultConsentStatus = true,
            legalGround = "Art. 6 para. 1 s. 1 lit. c GDPR",
            optOutUrl = "",
            policyOfProcessorUrl = "https://usercentrics.com/de/datenschutzerklarung/",
            categorySlug = "essential",
            retentionPeriod = 0,
            retentionPeriodDescription = "The consent data (given consent and revocation of consent) are stored for three years. The data will then be deleted immediately or given to the person responsible on request in the form of a data export.",
            iabId = "5",
            iabv2Id = null,
            dataProtectionOfficer = "datenschutz@usercentrics.com",
            privacyPolicyURL = "https://usercentrics.com/privacy-policy/",
            cookiePolicyURL = "",
            locationOfProcessing = "European Union",
            dataCollectedDescription = "",
            dataPurposesDescription = "",
            dataRecipientsDescription = "",
            legalBasisDescription = "",
            optOutDescription = "",
            thirdCountryTransfer = "Worldwide",
            defaultCategoryLabel = "Essential",
            description = "",
            cookieMaxAgeSeconds = null,
            usesNonCookieAccess = null,
            deviceStorageDisclosureUrl = null,
            isDeactivated = false,
            disableLegalBasis = false,
        )
    )
    private val fakeLabels = UsercentricsLabels(
        optin = "General Opt-In",
        dataScopes = "Data Scopes",
        dataAttributes = "Data Attributes",
        dataPurposes = "Data Purposes",
        dataProcessors = "Processing Company",
        dataControllers = "Data Controller",
        accepted = "yes",
        denied = "no",
        history = "History",
        settings = "Settings",
        subConsents = "Subservices",
        btnSelectAll = "Select all",
        btnAccept = "Accept",
        btnDeny = "Deny",
        btnChipName = "Privacy settings",
        statusActive = "active",
        statusInactive = "inactive",
        titleCorner = "This tool helps you to select and deactivate various tags / trackers / analytic tools used on this website.",
        headerCorner = "Privacy settings",
        btnSaveSettings = "Save settings",
        btnMore = "more",
        poweredBy = "Powered by <a href=\"https://usercentrics.com/?utm_source=cmp&utm_medium=powered_by\" rel=\"nofollow\" target=\"_blank\">Usercentrics Consent Management</a>",
        technologiesUsed = "Technologies Used",
        dataCollectedList = "Data Collected",
        processingCompanyTitle = "Processing Company",
        legalBasisList = "Legal Basis",
        retentionPeriod = "Retention Period",
        locationOfProcessing = "Location of Processing",
        transferToThirdCountries = "Transfer to Third Countries",
        furtherInformationOptOut = "Further Information and Opt-Out",
        dataProtectionOfficer = "Data Protection Officer of Processing Company",
        nameOfProcessingCompany = "Processing Company",
        addressOfProcessingCompany = "Address of processing company",
        optOut = "Click here to opt out from this processor across all domains",
        policyOf = "Click here to read the privacy policy of the data processor",
        searchPlaceholder = "Search Services",
        dataCollectedInfo = "This list represents all (personal) data that is collected by or through the use of this service.",
        legalBasisInfo = "In the following the required legal basis for the processing of data is listed.",
        locationofProcessingInfo = "This is the primary location where the collected data is being processed. If the data is also processed in other countries, you are informed separately.",
        retentionPeriodInfo = "The retention period is the time span the collected data is saved for the processing purposes. The data needs to be deleted as soon as it is no longer needed for the stated processing purposes.",
        dataRecipientsList = "Data Recipients",
        dataRecipientsListInfo = "In the following the recipients of the data collected are listed.",
        transferToThirdCountriesInfo = "This service may forward the collected data to a different country. Please note that this service might transfer the data outside of the EU/EEA and to a country without the required data protection standards. If the data is transferred to the US, there is a risk that your data can be processed by US authorities, for control and surveillance measures, possibly without legal remedies. Below you can find a list of countries to which the data is being transferred. This can be for different reasons like storing or processing.",
        dataProtectionOfficerInfo = "Below you can find the email address of the data protection officer of the processing company.",
        linkToDpaInfo = "Data Processing Agreement",
        dataPurposesInfo = "This list represents the purposes of the data collection and processing.",
        technologiesUsedInfo = "This list represents all technologies this service uses to collect data. Typical technologies are Cookies and Pixels that are placed in the browser.",
        btnBannerReadMore = "Read more",
        consentDescription = "Description of the use of the data",
        descriptionOfService = "Description of Service",
        technology = "Technology being used to process the data",
        notAvailable = "not available",
        noResults = "No results",
        btnViewFullConsentsList = "Display all Services",
        date = "Date",
        comments = "Comments",
        ago = "ago",
        justNow = "just now",
        minute = "minute",
        minutes = "minutes",
        hour = "hour",
        hours = "hours",
        day = "day",
        days = "days",
        month = "month",
        months = "months",
        year = "year",
        years = "years",
        consent = "Consent",
        categories = "Categories",
        language = "Language",
        btnSave = "Save Services",
        btnCancel = "Cancel changes",
        btnClose = "Close",
        btnReset = "Reset",
        btnMoreInfo = "More Info",
        btnAllOn = "Switch all on",
        btnAllOff = "Switch all off",
        btnSaveAndExit = "Save and close",
        btnBack = "Back",
        titleCenterPrimary = "Privacy Settings",
        titleCenterSecondary = "Privacy Settings",
        headerCenterPrimary = "Privacy settings",
        headerCenterSecondary = "Privacy settings",
        btnShowPrivacy = "Show privacy",
        btnActivateChangesAndCloseWindow = "Activate changes and close window",
        copy = "copy",
        copied = "copied",
        view = "view",
        more = "more",
        less = "less",
        consents = "Consents",
        btnModalSave = "Save settings",
        headerModalDescription = "Privacy settings",
        headerModal = "This tool helps you to select and deactivate various tags / trackers / analytic tools used on this website.",
        basic = "Basic",
        advanced = "Advanced",
        processingCompany = "Processing Company",
        cookiePolicyInfo = "Click here to read the cookie policy of the data processor",
        imprintLinkText = "Imprint",
        privacyPolicyLinkText = "Privacy Policy",
        cookiePolicyLinkText = "Cookie Policy",
        partnerPoweredByLinkText = "",
        iabBtnAcceptAll = "Accept All",
        iabCategoryNonIab = "Non IAB Vendors",
        iabCategoryNonIabDescription = "Vendors not yet registered with IAB Framework.",
        btnAcceptAll = "Accept All",
        iabViewByPurpose = "View by Purpose",
        iabExamplePersonalData = "Example for personal data: IP address",
        secondLayerAppendix = "",
        firstLayerTitle = "Privacy Settings",
        historyDescription = "",
        consentType = "Consent type",
        decision = "Decision",
        explicit = "Explicit",
        implicit = "Implicit",
        showMore = "Show more",
        storageInformation = "Storage Information",
        maximumAgeCookieStorage = "Maximum age of cookie storage",
        second = "second",
        seconds = "seconds",
        nonCookieStorage = "Non-cookie storage",
        detailedStorageInformation = "Detailed Storage Information",
        loadingStorageInformation = "Loading storage information",
        name = "Name",
        identifier = "Identifier",
        duration = "Duration",
        type = "Type",
        domain = "Domain",
        informationLoadingNotPossible = "Sorry, we could not load the required information.",
        yes = "yes",
        session = "Session",
        no = "no",
        tryAgain = "Try again?",
        anyDomain = "any domain (ex. first party cookie)",
        multipleDomains = "multiple subdomains may exist",
        storageInformationDescription = "Below you can see the longest potential duration for storage on a device, as set when using the cookie method of storage and if there are any other methods used.",
        storedInformation = "Stored Information",
        storedInformationDescription = "This service uses different means of storing information on a user’s device as listed below.",
        yesImplicit = "yes (website default)",
        noImplicit = "no (website default)"
    )
    private val fakeFirstLayer = FirstLayer(
        descriptionDefault = "",
        isCategoryTogglesEnabled = false,
        hideLanguageSwitch = false,
        hideButtonDeny = false,
        isOverlayEnabled = true,
        title = "",
        descriptionShort = "",
    )
    private val fakeSecondLayer = SecondLayer(
        tabsServicesLabel = "Services",
        tabsCategoriesIsEnabled = true,
        description = "",
        hideLanguageSwitch = false,
        tabsCategoriesLabel = "Categories",
        hideButtonDeny = false,
        tabsServicesIsEnabled = true,
        isOverlayEnabled = true,
        title = "",
        hideTogglesForServices = false,
    )
    private val fakeTCF2Settings = TCF2Settings(
        togglesSpecialFeaturesToggleOff = "Off",
        secondLayerTitle = "Privacy Settings Title",
        tabsVendorsLabel = "Vendors",
        labelsIabVendors = "Vendors who are part of the IAB TCF",
        buttonsDenyAllLabel = "Deny all",
        resurfacePeriodEnded = true,
        vendorSpecialPurposes = "Special Purposes",
        firstLayerAdditionalInfo = "",
        resurfaceVendorAdded = true,
        disabledSpecialFeatures = listOf(),
        resurfacePurposeChanged = true,
        firstLayerHideButtonDeny = false,
        hideLegitimateInterestToggles = false,
        secondLayerHideButtonDeny = false,
        secondLayerHideToggles = false,
        vendorToggleAll = false,
        togglesConsentToggleLabel = "Consent",
        labelsFeatures = "Features",
        firstLayerNoteGlobal =
        "Your choices for this website will be applied globally, which means they will be available to other websites that set your choices globally.",
        togglesSpecialFeaturesToggleOn = "On",
        vendorSpecialFeatures = "Special Features",
        resurfaceIABLegalBasisChanged = true,
        appLayerNoteResurface =
        "You can change your privacy settings or withdraw your consent at any time by opening the menu point Privacy Settings.",
        cmpVersion = 3,
        firstLayerDescription =
        "We and our third-party vendors use technologies (e.g. cookies) to store and/or access information on user's devices in order to process personal data such as IP addresses or browsing data. You may consent to the processing of your personal data for the listed purposes below. Alternatively you can set your preferences before consenting or refuse to consent. Please note that some vendors may process your personal data based on their legitimate business interest and do not ask for your consent. To exercise your right to object to processing based on legitimate interest please view our vendorlist.",
        consensuScriptPath = null,
        firstLayerShowDescriptions = false,
        labelsPurposes = "Purposes",
        firstLayerNoteResurface =
        "You can change your privacy settings or withdraw your consent at any time by clicking on our Privacy Button.",
        firstLayerTitle = "Privacy Information",
        vendorLegitimateInterestPurposes = "Purposes processed by Legitimate Interest",
        selectedStacks = listOf(),
        labelsNonIabPurposes = "Non-IAB Purposes",
        togglesLegIntToggleLabel = "Legitimate Interest",
        vendorPurpose = "Purposes processed by Consent",
        labelsNonIabVendors = "Vendors who are not part of the IAB TCF",
        purposeOneTreatment = false,
        cmpId = 5,
        vendorFeatures = "Features",
        secondLayerDescription =
        "You can access more detailed information below regarding all purposes and third-party vendors implemented on this website. You can adjust your privacy settings based on specific purposes and/or at a vendor level at any time.",
        firstLayerNoteService =
        "Your choices for this website will be applied on this page only. You can change your Privacy Settings or withdraw your consent at any time by clicking on our Privacy Button.",
        publisherCountryCode = "DE",
        buttonsSaveLabel = "Save Settings",
        selectedVendorIds = listOf(),
        buttonsAcceptAllLabel = "Accept all",
        hideNonIabOnFirstLayer = false,
        linksManageSettingsLabel = "Manage Settings",
        firstLayerHideToggles = false,
        labelsDisclaimer =
        "All choices on this website will be applied globally, which means they will be available on other websites that set your choices globally. By clicking on our Privacy Button in the bottom left corner, you can change your settings or withdraw your consent at any time.",
        gdprApplies = true,
        consensuDomain = null,
        linksVendorListLinkLabel = "Vendorlist",
        tabsPurposeLabel = "Purposes"
    )
    private val fakeCCPASettings = CCPASettings(
        secondLayerHideLanguageSwitch = false,
        secondLayerTitle = "Privacy Settings Title",
        reshowCMP = true,
        iabAgreementExists = false,
        optOutNoticeLabel = "Do not sell my personal information",
        firstLayerHideLanguageSwitch = false,
        btnSave = "OK",
        firstLayerDescription =
        "We and our partners are using technologies like cookies and process personal data in order to improve your experience. In case of sale of your personal information you may exercise your consumer right to opt-out by activating the toggle 'Do Not Sell My Personal Information' below. For detailed information about the categories of personal information we collect and the purposes for which information may be used and which Data Processing Services may have access to this information please click on 'More Information' or refer to our privacy policy.",
        showOnPageLoad = false,
        btnMoreInfo = "More Information",
        firstLayerTitle = "Privacy Information",
        appFirstLayerDescription =
        "We and our partners are using technologies like cookies and process personal data in order to improve your experience. In case of sale of your personal information you may exercise your consumer right to opt-out by activating the toggle 'Do Not Sell My Personal Information' below. For detailed information about the categories of personal information we collect and the purposes for which information may be used and which Data Processing Services may have access to this information please refer to our privacy policy.",
        isActive = false,
        secondLayerDescription =
        "Here you can find detailed information about the categories of personal information we collect and the purposes for which information may be used and which Data Processing Services may have access to this information.",
        firstLayerMobileDescriptionIsActive = false,
        reshowAfterDays = 365,
        firstLayerMobileDescription =
        "We and our partners are using technologies like cookies and process personal data in order to improve your experience. In case of sale of your personal information you may exercise your consumer right to opt-out by activating the toggle 'Do Not Sell My Personal Information' below.",
    )
    private val fakeCustomization = UsercentricsCustomization(
        color = CustomizationColor(
            primary = "0045A5"
        ),
        font = CustomizationFont(
            family =
            "BlinkMacSystemFont,-apple-system,Segoe UI,Roboto,Oxygen-Sans,Ubuntu,Cantarell,Fira Sans,Droid Sans,Helvetica Neue,Helvetica,Arial,sans-serif",
            size = 14
        ),
        logoUrl = "https://www.munich-startup.de/wp-content/uploads/2018/01/usercentrics-logo-4c@4x.png"
    )
    val fakeSettings = UsercentricsSettings(
        labels = fakeLabels,
        showInitialViewForVersionChange = listOf(),
        reshowBanner = null,
        displayOnlyForEU = false,
        urlConsentInfo = "",
        updatedAt = "2020-10-26T14:21:05.933Z",
        secondLayer = fakeSecondLayer,
        cookiePolicyUrl = "",
        tcf2 = fakeTCF2Settings,
        ccpa = fakeCCPASettings,
        btnDenyIsVisible = true,
        privacyPolicyUrl = "https://usercentrics.com/privacy-policy/",
        firstLayer = fakeFirstLayer,
        showLanguageDropdown = true,
        imprintUrl = "https://usercentrics.com/legal-notice/",
        btnMoreInfoIsVisible = true,
        bannerMessage = "Privacy Settings test description.",
        bannerMobileDescriptionIsActive = false,
        dataController = "GDPR",
        bannerMobileDescription = "",
        version = "6.0.4",
        isLatest = true,
        language = "en",
        tcf2Enabled = false,
        settingsId = "lQ_Dio7QL",
        languagesAvailable = listOf("en", "de"),
        createdAt = "2020-10-26T14:21:05.933Z",
        enablePoweredBy = true,
        editableLanguages = listOf("en", "de"),
        partnerPoweredByLogoUrl = "",
        customization = fakeCustomization,
        moreInfoButtonUrl = "",
        iabConsentIsActive = false,
        partnerPoweredByUrl = ""
    )

    // From the debugger
    val call = FakeFlutterMethodCall(method = "getCMPData", arguments = null)
    private val expectedFirstLayer = mapOf(
        "isOverlayEnabled" to true,
        "isCategoryTogglesEnabled" to false,
        "hideButtonDeny" to false,
        "hideLanguageSwitch" to false,
        "title" to "",
        "descriptionDefault" to "",
        "descriptionShort" to "",
    )
    private val expectedSecondLayer = mapOf(
        "tabsCategoriesLabel" to "Categories",
        "tabsServicesLabel" to "Services",
        "isOverlayEnabled" to true,
        "tabsCategoriesIsEnabled" to true,
        "tabsServicesIsEnabled" to true,
        "hideButtonDeny" to false,
        "hideLanguageSwitch" to false,
        "title" to "",
        "description" to "",
    )
    private val expectedLabels = mapOf(
        "btnAcceptAll" to "Accept All",
        "btnDeny" to "Deny",
        "btnSave" to "Save Services",
        "firstLayerTitle" to "Privacy Settings",
        "accepted" to "yes",
        "denied" to "no",
        "date" to "Date",
        "decision" to "Decision",
        "dataCollectedList" to "Data Collected",
        "dataCollectedInfo" to "This list represents all (personal) data that is collected by or through the use of this service.",
        "locationOfProcessing" to "Location of Processing",
        "transferToThirdCountries" to "Transfer to Third Countries",
        "dataPurposes" to "Data Purposes",
        "dataPurposesInfo" to "This list represents the purposes of the data collection and processing.",
        "dataRecipientsList" to "Data Recipients",
        "descriptionOfService" to "Description of Service",
        "history" to "History",
        "historyDescription" to "",
        "legalBasisList" to "Legal Basis",
        "legalBasisInfo" to "In the following the required legal basis for the processing of data is listed.",
        "processingCompanyTitle" to "Processing Company",
        "retentionPeriod" to "Retention Period",
        "technologiesUsed" to "Technologies Used",
        "technologiesUsedInfo" to "This list represents all technologies this service uses to collect data. Typical technologies are Cookies and Pixels that are placed in the browser.",
        "cookiePolicyInfo" to "Click here to read the cookie policy of the data processor",
        "optOut" to "Click here to opt out from this processor across all domains",
        "policyOf" to "Click here to read the privacy policy of the data processor",
        "imprintLinkText" to "Imprint",
        "privacyPolicyLinkText" to "Privacy Policy",
        "categories" to "Categories",
        "anyDomain" to "any domain (ex. first party cookie)",
        "day" to "day",
        "days" to "days",
        "domain" to "Domain",
        "duration" to "Duration",
        "informationLoadingNotPossible" to "Sorry, we could not load the required information.",
        "hour" to "hour",
        "hours" to "hours",
        "identifier" to "Identifier",
        "maximumAgeCookieStorage" to "Maximum age of cookie storage",
        "minute" to "minute",
        "minutes" to "minutes",
        "month" to "month",
        "months" to "months",
        "multipleDomains" to "multiple subdomains may exist",
        "no" to "no",
        "nonCookieStorage" to "Non-cookie storage",
        "seconds" to "seconds",
        "session" to "Session",
        "loadingStorageInformation" to "Loading storage information",
        "storageInformation" to "Storage Information",
        "detailedStorageInformation" to "Detailed Storage Information",
        "tryAgain" to "Try again?",
        "type" to "Type",
        "year" to "year",
        "years" to "years",
        "yes" to "yes",
        "storageInformationDescription" to "Below you can see the longest potential duration for storage on a device, as set when using the cookie method of storage and if there are any other methods used.",
        "btnBannerReadMore" to "Read more",
        "linkToDpaInfo" to "Data Processing Agreement",
        "second" to "second",
    )
    private val expectedTCF2Settings = mapOf(
        "firstLayerTitle" to "Privacy Information",
        "secondLayerTitle" to "Privacy Settings Title",
        "tabsPurposeLabel" to "Purposes",
        "tabsVendorsLabel" to "Vendors",
        "labelsFeatures" to "Features",
        "labelsIabVendors" to "Vendors who are part of the IAB TCF",
        "labelsNonIabPurposes" to "Non-IAB Purposes",
        "labelsNonIabVendors" to "Vendors who are not part of the IAB TCF",
        "labelsPurposes" to "Purposes",
        "vendorFeatures" to "Features",
        "vendorLegitimateInterestPurposes" to "Purposes processed by Legitimate Interest",
        "vendorPurpose" to "Purposes processed by Consent",
        "vendorSpecialFeatures" to "Special Features",
        "vendorSpecialPurposes" to "Special Purposes",
        "togglesConsentToggleLabel" to "Consent",
        "togglesLegIntToggleLabel" to "Legitimate Interest",
        "buttonsAcceptAllLabel" to "Accept all",
        "buttonsDenyAllLabel" to "Deny all",
        "buttonsSaveLabel" to "Save Settings",
        "linksManageSettingsLabel" to "Manage Settings",
        "linksVendorListLinkLabel" to "Vendorlist",
        "cmpId" to 5,
        "cmpVersion" to 3,
        "firstLayerHideToggles" to false,
        "secondLayerHideToggles" to false,
        "hideLegitimateInterestToggles" to false,
        "firstLayerHideButtonDeny" to false,
        "secondLayerHideButtonDeny" to false,
        "publisherCountryCode" to "DE",
        "purposeOneTreatment" to false,
        "selectedVendorIds" to listOf<Any>(),
        "gdprApplies" to true,
        "consensuDomain" to null,
        "consensuScriptPath" to null,
        "selectedStacks" to listOf<Any>(),
        "disabledSpecialFeatures" to listOf<Any>(),
        "firstLayerShowDescriptions" to false,
        "hideNonIabOnFirstLayer" to false,
        "resurfaceIABLegalBasisChanged" to true,
        "resurfacePeriodEnded" to true,
        "resurfacePurposeChanged" to true,
        "resurfaceVendorAdded" to true,
        "vendorToggleAll" to false,
        "firstLayerDescription" to "We and our third-party vendors use technologies (e.g. cookies) to store and/or access information on user's devices in order to process personal data such as IP addresses or browsing data. You may consent to the processing of your personal data for the listed purposes below. Alternatively you can set your preferences before consenting or refuse to consent. Please note that some vendors may process your personal data based on their legitimate business interest and do not ask for your consent. To exercise your right to object to processing based on legitimate interest please view our vendorlist.",
        "firstLayerAdditionalInfo" to "",
        "secondLayerDescription" to "You can access more detailed information below regarding all purposes and third-party vendors implemented on this website. You can adjust your privacy settings based on specific purposes and/or at a vendor level at any time.",
        "togglesSpecialFeaturesToggleOn" to "On",
        "togglesSpecialFeaturesToggleOff" to "Off",
        "appLayerNoteResurface" to "You can change your privacy settings or withdraw your consent at any time by opening the menu point Privacy Settings.",
        "firstLayerNoteGlobal" to "Your choices for this website will be applied globally, which means they will be available to other websites that set your choices globally.",
        "firstLayerNoteResurface" to "You can change your privacy settings or withdraw your consent at any time by clicking on our Privacy Button.",
    )
    private val expectedCCPASettings = mapOf(
        "optOutNoticeLabel" to "Do not sell my personal information",
        "btnSave" to "OK",
        "firstLayerTitle" to "Privacy Information",
        "isActive" to false,
        "showOnPageLoad" to false,
        "reshowCMP" to true,
        "reshowAfterDays" to 365,
        "iabAgreementExists" to false,
        "firstLayerDescription" to "We and our partners are using technologies like cookies and process personal data in order to improve your experience. In case of sale of your personal information you may exercise your consumer right to opt-out by activating the toggle 'Do Not Sell My Personal Information' below. For detailed information about the categories of personal information we collect and the purposes for which information may be used and which Data Processing Services may have access to this information please click on 'More Information' or refer to our privacy policy.",
        "appFirstLayerDescription" to "We and our partners are using technologies like cookies and process personal data in order to improve your experience. In case of sale of your personal information you may exercise your consumer right to opt-out by activating the toggle 'Do Not Sell My Personal Information' below. For detailed information about the categories of personal information we collect and the purposes for which information may be used and which Data Processing Services may have access to this information please refer to our privacy policy.",
        "firstLayerMobileDescriptionIsActive" to false,
        "firstLayerMobileDescription" to "We and our partners are using technologies like cookies and process personal data in order to improve your experience. In case of sale of your personal information you may exercise your consumer right to opt-out by activating the toggle 'Do Not Sell My Personal Information' below.",
        "firstLayerHideLanguageSwitch" to false,
        "secondLayerTitle" to "Privacy Settings Title",
        "secondLayerDescription" to "Here you can find detailed information about the categories of personal information we collect and the purposes for which information may be used and which Data Processing Services may have access to this information.",
        "secondLayerHideLanguageSwitch" to false,
        "btnMoreInfo" to "More Information",
    )
    private val expectedCustomization = mapOf(
        "color" to mapOf(
            "primary" to "0045A5",
            "acceptBtnText" to null,
            "acceptBtnBackground" to null,
            "denyBtnText" to null,
            "denyBtnBackground" to null,
            "saveBtnText" to null,
            "saveBtnBackground" to null,
            "linkIcon" to null,
            "linkFont" to null,
            "text" to null,
            "layerBackground" to null,
            "overlay" to null,
            "toggleInactiveBackground" to null,
            "toggleInactiveIcon" to null,
            "toggleActiveBackground" to null,
            "toggleActiveIcon" to null,
            "toggleDisabledBackground" to null,
            "toggleDisabledIcon" to null,
            "secondLayerTab" to null,
            "moreBtnBackground" to null,
            "moreBtnText" to null,
        ),
        "font" to mapOf(
            "family" to "BlinkMacSystemFont,-apple-system,Segoe UI,Roboto,Oxygen-Sans,Ubuntu,Cantarell,Fira Sans,Droid Sans,Helvetica Neue,Helvetica,Arial,sans-serif",
            "size" to 14
        ),
        "logoUrl" to "https://www.munich-startup.de/wp-content/uploads/2018/01/usercentrics-logo-4c@4x.png",
        "borderRadiusLayer" to null,
        "useBackgroundShadow" to null,
        "borderRadiusButton" to null,
        "overlayOpacity" to null,
    )
    val expectedSettings = mapOf(
        "labels" to expectedLabels,
        "showInitialViewForVersionChange" to listOf<Any>(),
        "reshowBanner" to null,
        "displayOnlyForEU" to false,
        "urlConsentInfo" to "",
        "updatedAt" to "2020-10-26T14:21:05.933Z",
        "secondLayer" to expectedSecondLayer,
        "cookiePolicyUrl" to "",
        "tcf2" to expectedTCF2Settings,
        "ccpa" to expectedCCPASettings,
        "btnDenyIsVisible" to true,
        "privacyPolicyUrl" to "https://usercentrics.com/privacy-policy/",
        "firstLayer" to expectedFirstLayer,
        "showLanguageDropdown" to true,
        "imprintUrl" to "https://usercentrics.com/legal-notice/",
        "btnMoreInfoIsVisible" to true,
        "bannerMessage" to "Privacy Settings test description.",
        "bannerMobileDescriptionIsActive" to false,
        "dataController" to "GDPR",
        "bannerMobileDescription" to "",
        "version" to "6.0.4",
        "isLatest" to true,
        "language" to "en",
        "tcf2Enabled" to false,
        "settingsId" to "lQ_Dio7QL",
        "languagesAvailable" to listOf("en", "de"),
        "createdAt" to "2020-10-26T14:21:05.933Z",
        "enablePoweredBy" to true,
        "editableLanguages" to listOf("en", "de"),
        "partnerPoweredByLogoUrl" to "",
        "customization" to expectedCustomization,
        "moreInfoButtonUrl" to "",
        "iabConsentIsActive" to false,
        "partnerPoweredByUrl" to ""
    )
    val expectedCategories = listOf(
        mapOf(
            "categorySlug" to "essential",
            "label" to "Essential",
            "description" to "These technologies are required to activate the core functionality of the website.",
            "isEssential" to true,
        )
    )
    val expectedUserLocation = mapOf(
        "countryCode" to "PT",
        "countryName" to "Portugal",
        "regionCode" to "",
        "isInEU" to true,
        "isInUS" to false,
        "isInCalifornia" to false,
    )
    val expectedServices = listOf(
        mapOf(
            "templateId" to "ABC",
            "version" to "1.2.3",
            "type" to "predefined",
            "dataProcessor" to "Google Ads",
            "dataPurposes" to listOf("Advertising Conversion Tracking"),
            "processingCompany" to "Google Ireland Limited, Google Building Gordon House",
            "nameOfProcessingCompany" to "Google Ireland Limited",
            "addressOfProcessingCompany" to "Google Building Gordon House",
            "descriptionOfService" to "This is a conversion tracking service. ",
            "languagesAvailable" to listOf("en"),
            "dataCollectedList" to listOf("IP adress"),
            "dataPurposesList" to listOf("Analytics"),
            "dataRecipientsList" to listOf("Google Ireland Limited"),
            "legalBasisList" to listOf("Art. 6 para. 1 s. 1 lit. a GDPR"),
            "retentionPeriodList" to listOf<String>(),
            "subConsents" to listOf<String>(),
            "cookieNames" to listOf<String>(),
            "language" to "en",
            "isLatest" to false,
            "isShared" to false,
            "shareCustomConsent" to "",
            "linkToDpa" to "",
            "defaultConsentStatus" to true,
            "legalGround" to "Art. 6 para. 1 s. 1 lit. c GDPR",
            "optOutUrl" to "",
            "policyOfProcessorUrl" to "https://usercentrics.com/de/datenschutzerklarung/",
            "categorySlug" to "essential",
            "retentionPeriod" to 0L,
            "retentionPeriodDescription" to "The consent data (given consent and revocation of consent) are stored for three years. The data will then be deleted immediately or given to the person responsible on request in the form of a data export.",
            "iabId" to "5",
            "iabv2Id" to null,
            "dataProtectionOfficer" to "datenschutz@usercentrics.com",
            "privacyPolicyURL" to "https://usercentrics.com/privacy-policy/",
            "cookiePolicyURL" to "",
            "locationOfProcessing" to "European Union",
            "dataCollectedDescription" to "",
            "dataPurposesDescription" to "",
            "dataRecipientsDescription" to "",
            "legalBasisDescription" to "",
            "optOutDescription" to "",
            "thirdCountryTransfer" to "Worldwide",
            "defaultCategoryLabel" to "Essential",
            "description" to "",
            "cookieMaxAgeSeconds" to null,
            "usesNonCookieAccess" to null,
            "deviceStorageDisclosureUrl" to null,
            "isDeactivated" to false,
            "disableLegalBasis" to false,
            "isEssential" to false,
        )
    )

}
